/*
 *   (C) COPYRIGHT International Business Machines Corp. 1991, 1995
 *   All Rights Reserved
 *   Licensed Materials - Property of IBM
 *   US Government Users Restricted Rights - Use, duplication or
 *   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifndef _ICONV_H
  #define _ICONV_H

  #ifndef __ICONVP_H
    typedef void *iconv_t;
  #endif

  #ifndef CCSID_DEF
    #define CCSID_DEF
    typedef unsigned int 	CCSID;
  #endif

  #include <stddef.h>

#undef EILSEQ
#define EILSEQ         52
#undef E2BIG
#define E2BIG          53
#undef ENAMETOOLONG
#define ENAMETOOLONG    86      /* File name too long           */

#ifdef __cplusplus
extern "C" {
#endif

  iconv_t iconv_open (const char*, const char*);
  size_t  iconv (iconv_t, char**, size_t*, char**, size_t*);
  int     iconv_close (iconv_t);

#ifdef __cplusplus
}
#endif

#endif /*!_ICONV_H*/
